#include "human_car_parsing.h"
//#include <cv.h>
#include <highgui.h>
#include <opencv2/opencv.hpp>
#include <fstream>
#include <iostream>
#include "sy_common.h"

#ifdef _WIN32
#include<windows.h>
#else
#include <sys/time.h>
#endif


using namespace std;
//using namespace cv;

//string up[12] = { "T", "//", "", "", "ë", "Ƥ/п", "޷", "/", "", "ȹ", "", "" };
//string up_color[12] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "" };
//string down[6] = { "", "̿", "ȹ", "ȹ", "ȹ", "" };
//string down_color[12] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "" };
//string bao[5] = { "ް", "", "˫", "", "Ǯ" };
//string bag_color[12] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "" };
//string head[6] = { "", "̷", "ͷ", "ñ", "ͷ", "" };
//string clothing_text[5] = { "ɫ", "黨", "", "", "" };
//string sex[3] = { "", "Ů", "" };
//string figure[3] = { "", "", "" };
//string nationality[5] = { "", "ά", "", "", "" };
//string age[6] = { "׶", "ͯ", "", "", "", "" };
//string eye[4] = { "۾", "۾", "ī", "" };
//string mouth[3] = { "", "", "" };
//string weibo[3] = { "Χ", "ͨΧ", "ͷΧ" };
//
//string carColor[13] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "", "" };
//string orient[3] = { "", "", "" };
//string drivenum[4] = { "0", "1", "2", "" };
//string dasan[2] = { "", "" };
//string take[2] = { "", "Ʒ" };

static std::string head[] = { "", "̷", "ͷ", "" };
static std::string eye[] = { "δ۾", "۾" };
static std::string mouth[] = { "δ", "" };
static std::string weibo[] = { "δΧ", "Χ" };
static std::string up[] = { "T/", "", "ë", "", "ȹ", "" };
static std::string up_color[] = { "", "", "", "", "", "", "", "ɫ", "" };
static std::string clothing_text[] = { "ɫ", "黨", "/", "" };
static std::string bao[] = { "ް", "" };
static std::string sex[] = { "", "Ů", "" };
static std::string age[] = { "С", "", "" };
static std::string carColor[] = { "", "", "", "" };
static std::string orient[] = { "", "", "" };
static std::string dasan[] = { "", "" };
static std::string take[] = { "", "" };

//string top_list[12] = { "T", "//", "", "", "ë", "Ƥ/п", "޷", "/", "", "ȹ", "", "" };
//string top_color_list[12] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "" };
//string bottom_list[6] = { "", "̿", "ȹ", "ȹ", "ȹ", "" };
//string bottom_color_list[12] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "" };
//string bag_list[5] = { "ް", "", "˫", "", "Ǯ" };
//string bag_color_list[12] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "" };
//string head_feature_list[6] = { "", "̷", "ͷ", "ñ", "ͷ", "" };
//string clothes_pattern_list[5] = { "ɫ", "黨", "", "", "" };
//string gender_list[3] = { "", "Ů", "" };
//string body_size_list[3] = { "", "", "" };
//string ethnic_group_list[5] = { "", "ά", "", "", "" };
//string age_group_list[6] = { "׶", "ͯ", "", "", "", "" };
//string eye_feature_list[4] = { "۾", "۾", "ī", "" };
//string mouth_feature_list[3] = { "", "", "" };
//string neck_feature_list[3] = { "Χ", "ͨΧ", "ͷΧ" };
//string vehicle_color_list[13] = { "", "", "", "", "", "", "", "", "", "", "ɫ", "", "" };
//string direction_list[3] = { "", "", "" };
//string passenger_count_list[4] = { "0", "1", "2", "" };
//string umbrella_list[2] = { "", "" };
//string belongings_list[2] = { "", "Ʒ" };


//const int FIR_INDEX_SIZE = 20;
//const int HCP_SEC_INDEX_SIZE[HCP_FIR_INDEX_SIZE] = { 12,12,6,12,5,12,6,5,3,3,5,6,4,3,3,13,3,4,2,2 };
//const int HCP_SEC_INDEX_SIZE[HCP_ATTRI_INDEX_SIZE] = { 3,2,2,2,6,5,4,2,3,3,5,3,2,2 };

////****************** СĽ ********************//

//void hcp_all_result()
//{
//	printf("%s\n", hcp_get_version());
//#ifdef _WIN32
//	LARGE_INTEGER begin, end, freq;
//	QueryPerformanceFrequency(&freq);
//#else
//	struct timeval tv1, tv2;
//#endif
//	double totalTime = 0.0;
//
//	/*ʼ*/
//	void *tools;
//	hcp_param param;
//	//	param.mode = "cpu";
//	param.mode = DEVICE_GPU;
//	param.gpuid = 0;
//	if (hcp_init(&tools, param) != 0)
//		cout << "hcp_init failed!" << endl;
//
//
//	int count = 11;
//	//	while (count--)
//	{
//		for (int index = 0; index < 10; index++)
//			//		for (int index = 0; index < 1; index++)
//		{
//			char imgpath[260];
//			cv::Mat img;
//
//#ifdef _MSC_VER
//			sprintf(imgpath, "../../data/HumanCarImageData/%d.jpg", index);// b);
//#else
//			sprintf(imgpath, "/home/jlliu/objecteye/video_structure/HumanCarParsing/data/HumanCarImageData/%d.jpg", index);
//
//#endif
//			img = cv::imread(imgpath);
//
//			ctools_result *result;
//
//			/*ﳵṹ*/
//#ifdef _WIN32
//			QueryPerformanceCounter(&begin);
//#else
//			gettimeofday(&tv1, NULL);
//#endif
//
//			hcp_process(tools, img.data, img.cols, img.rows, img.channels(), &result);
//
//#ifdef _WIN32
//			QueryPerformanceCounter(&end);
//			printf("hcp process time: %.2f\n", (double)(end.QuadPart - begin.QuadPart) * 1000 / (double)freq.QuadPart);
//#else
//			gettimeofday(&tv2, NULL);
//			long dt1 = tv1.tv_sec * 1000 + tv1.tv_usec / 1000;
//			long dt2 = tv2.tv_sec * 1000 + tv2.tv_usec / 1000;
//			printf("hcp process time: %ld ms\n", dt2 - dt1);
//#endif
//
//			/*ṹ*/
//			//cout << endl << imgpath << " " << endl;
//			cout << imgpath << " " << endl;
//
//			ctools_result &cur_result = result[0];
//			int big_class_count = cur_result.obj_count_;
//			if (big_class_count != FIR_INDEX_SIZE)
//			{
//				printf("big_class_count: %d, wrong result.\n", big_class_count);
//				break;
//			}
//
//			for (size_t i = 0; i < FIR_INDEX_SIZE; i++)
//			{
//				//ͳƽ
//				int resIndex = 0;
//				float resMaxprob = -100;
//
//				ctools_obj_result &index_score = cur_result.obj_results_[i];
//				for (int j = 0; j < index_score.data_count_; j++)
//				{
//					if (index_score.data_[j] > resMaxprob)
//					{
//						resMaxprob = index_score.data_[j];
//
//						resIndex = j;
//					}
//				}
//				//
//				switch (i)
//				{
//				case 0:
//					cout << up[resIndex] << " ";
//					break;
//				case 1:
//					cout << up_color[resIndex] << " ";
//					break;
//				case 2:
//					cout << down[resIndex] << " ";
//					break;
//				case 3:
//					cout << down_color[resIndex] << " ";
//					break;
//				case 4:
//					cout << bao[resIndex] << " ";
//					break;
//				case 5:
//					cout << bag_color[resIndex] << " ";
//					break;
//				case 6:
//					cout << head[resIndex] << " ";
//					break;
//				case 7:
//					cout << clothing_text[resIndex] << " ";
//					break;
//				case 8:
//					cout << sex[resIndex] << " ";
//					break;
//				case 9:
//					cout << figure[resIndex] << " ";
//					break;
//				case 10:
//					cout << nationality[resIndex] << " ";
//					break;
//				case 11:
//					cout << age[resIndex] << " ";
//					break;
//				case 12:
//					cout << eye[resIndex] << " ";
//					break;
//				case 13:
//					cout << mouth[resIndex] << " ";
//					break;
//				case 14:
//					cout << weibo[resIndex] << " ";
//					break;
//				case 15:
//					cout << carColor[resIndex] << " ";
//					break;
//				case 16:
//					cout << orient[resIndex] << " ";
//					break;
//				case 17:
//					cout << drivenum[resIndex] << " ";
//					break;
//				case 18:
//					cout << dasan[resIndex] << " ";
//					break;
//				case 19:
//					cout << take[resIndex] << " ";
//					break;
//				default:
//					break;
//				}
//			}
//			cout << endl;
//		}
//	}
//
//	//	cout << "AVG TIME: " << totalTime / 100 << endl;
//		/*ͷԴ*/
//	hcp_release(&tools);
//}


//****************** شļ ********************//
void hcp_one_result()
{
	printf("%s\n", hcp_get_version());
	/*ʼ*/
	void *tools;
	hcp_param param;
	param.mode = DEVICE_GPU;
	param.gpuid = 3;
	if (hcp_init(&tools, param) != 0)
		cout << "hcp_init failed!" << endl;


	for (int index = 0; index < 10; index++)
	{
		char imgpath[260];
		cv::Mat img;

#ifdef _MSC_VER
		sprintf(imgpath, "../../data/HumanCarImageData/%d.jpg", index);// b);
#else
		sprintf(imgpath, "/home/jlliu/objecteye/video_structure/HumanCarParsing/data/HumanCarImageData/%d.jpg", index);

#endif
		img = cv::imread(imgpath);
		sy_img syimg;
		syimg.set_data(img.cols, img.rows, img.channels(), img.data);

		/*ʼṹ*/
		hcp_analysis_result result;

		/*ﳵṹ*/
		hcp_process(tools, syimg, &result);

		/*ṹ*/
		cout << endl << imgpath << " " << endl;

		for (size_t i = 0; i < HCP_ATTRI_INDEX_SIZE; i++)
		{
			//ͳƽ
			int resIndex = result.res_objs[i].res_index;
			//
			switch (i)
			{
			case 0:
				std::cout << head[resIndex] << " ";
				break;
			case 1:
				std::cout << eye[resIndex] << " ";
				break;
			case 2:
				std::cout << mouth[resIndex] << " ";
				break;
			case 3:
				std::cout << weibo[resIndex] << " ";
				break;
			case 4:
				std::cout << up[resIndex] << " ";
				break;
			case 5:
				std::cout << up_color[resIndex] << " ";
				break;
			case 6:
				std::cout << clothing_text[resIndex] << " ";
				break;
			case 7:
				std::cout << bao[resIndex] << " ";
				break;
			case 8:
				std::cout << sex[resIndex] << " ";
				break;
			case 9:
				std::cout << age[resIndex] << " ";
				break;
			case 10:
				std::cout << carColor[resIndex] << " ";
				break;
			case 11:
				std::cout << orient[resIndex] << " ";
				break;
			case 12:
				std::cout << dasan[resIndex] << " ";
				break;
			case 13:
				std::cout << take[resIndex] << " ";
				break;
			default:
				break;
			}

			
		}
		cout << endl;
	}
	/*ͷԴ*/
	hcp_release(&tools);
}

void hcp_batch_test()
{
	printf("%s\n", hcp_get_version());
	const int batchsize = 20;

	void *tools;
	hcp_param param;
	param.mode = DEVICE_GPU;
	param.gpuid = 0;
 param.engine = ENGINE_TENSORRT;
	param.serialize_file = "HCP";
	param.max_batch = 20;

	if (hcp_init(&tools, param) != 0)
		cout << "hcp_init failed!" << endl;

	/*ʼṹ*/
	hcp_analysis_result result[batchsize];
	sy_img images[batchsize];
	cv::Mat img[batchsize];

	char strpath[1024];
	memset(strpath, 0, sizeof(strpath));
	for (int b = 0; b < batchsize; b++)
	{
#ifdef _MSC_VER
		sprintf(strpath, "../../data/HumanCarImageData/RC_75547.jpg", b);
#else
		sprintf(strpath, "../../data/HumanCarImageData/RC_75547.jpg", b);

#endif
		img[b] = cv::imread(strpath);
		images[b].set_data(img[b].cols, img[b].rows, img[b].channels(), img[b].data);
	}

#ifdef _MSC_VER
	LARGE_INTEGER nFreq, nBeginTime, nEndTime;
	QueryPerformanceFrequency(&nFreq);
#else
	struct timeval t1, t2;
#endif
	double time_val = 0;
	vector<double> time_Array;

	int count = 1000;
	while (count--)
	{

#ifdef _MSC_VER
		QueryPerformanceCounter(&nBeginTime);
#else
		gettimeofday(&t1, NULL);

#endif

		hcp_batch(tools, images, batchsize, result);

#ifdef _MSC_VER
		QueryPerformanceCounter(&nEndTime);
		time_val = (double)(nEndTime.QuadPart - nBeginTime.QuadPart) * 1000 / (double)nFreq.QuadPart;
		printf("hcp_batch cost: %.2f ms  \n", time_val);
#else
		gettimeofday(&t2, NULL);
		time_val = ((t2.tv_sec - t1.tv_sec) * 1000000 + t2.tv_usec - t1.tv_usec) / 1000.0;
		printf("hcp_batch cost= %lf ms\n", time_val);
#endif
		time_Array.push_back(time_val);
	}
	double total = 0;
	for (int n = 1; n < time_Array.size(); n++)
	{
		total += time_Array[n];
	}

	printf("hcp_batch avg cost: %.2f\n", total / (time_Array.size() - 1));


	for (int b = 0; b < batchsize; b++)
	{
		for (int i = 0; i < HCP_ATTRI_INDEX_SIZE; i++)
		{
			int resIndex = result[b].res_objs[i].res_index;
			cout << resIndex << " ";
			////
			/*switch (i)
			{
			case 0:
				std::cout << head[resIndex] << " ";
				break;
			case 1:
				std::cout << eye[resIndex] << " ";
				break;
			case 2:
				std::cout << mouth[resIndex] << " ";
				break;
			case 3:
				std::cout << weibo[resIndex] << " ";
				break;
			case 4:
				std::cout << up[resIndex] << " ";
				break;
			case 5:
				std::cout << up_color[resIndex] << " ";
				break;
			case 6:
				std::cout << clothing_text[resIndex] << " ";
				break;
			case 7:
				std::cout << bao[resIndex] << " ";
				break;
			case 8:
				std::cout << sex[resIndex] << " ";
				break;
			case 9:
				std::cout << age[resIndex] << " ";
				break;
			case 10:
				std::cout << carColor[resIndex] << " ";
				break;
			case 11:
				std::cout << orient[resIndex] << " ";
				break;
			case 12:
				std::cout << dasan[resIndex] << " ";
				break;
			case 13:
				std::cout << take[resIndex] << " ";
				break;
			default:
				break;
			}*/
		}
		cout << endl << endl;
	}
	hcp_release(&tools);
}

int main()
{
	hcp_batch_test();
	//int count = 100;
	//while (count--)
	//hcp_all_result();    //Сļ
	//hcp_one_result();    //شļ

#ifdef _MSC_VER
	system("pause");
#endif  

	return 0;
}



//20
//switch (i)
//{
//case 0:
//	cout << up[resIndex] << " ";
//	break;
//case 1:
//	cout << up_color[resIndex] << " ";
//	break;
//case 2:
//	cout << down[resIndex] << " ";
//	break;
//case 3:
//	cout << down_color[resIndex] << " ";
//	break;
//case 4:
//	cout << bao[resIndex] << " ";
//	break;
//case 5:
//	cout << bag_color[resIndex] << " ";
//	break;
//case 6:
//	cout << head[resIndex] << " ";
//	break;
//case 7:
//	cout << clothing_text[resIndex] << " ";
//	break;
//case 8:
//	cout << sex[resIndex] << " ";
//	break;
//case 9:
//	cout << figure[resIndex] << " ";
//	break;
//case 10:
//	cout << nationality[resIndex] << " ";
//	break;
//case 11:
//	cout << age[resIndex] << " ";
//	break;
//case 12:
//	cout << eye[resIndex] << " ";
//	break;
//case 13:
//	cout << mouth[resIndex] << " ";
//	break;
//case 14:
//	cout << weibo[resIndex] << " ";
//	break;
//case 15:
//	cout << carColor[resIndex] << " ";
//	break;
//case 16:
//	cout << orient[resIndex] << " ";
//	break;
//case 17:
//	cout << drivenum[resIndex] << " ";
//	break;
//case 18:
//	cout << dasan[resIndex] << " ";
//	break;
//case 19:
//	cout << take[resIndex] << " ";
//	break;
//default:
//	break;
//}